"""Simple line-oriented connection class."""

import socket
import string

is_connected=0

def connect(server,port):
    global sock,is_connected,lines

    sock=socket.socket(socket.AF_INET,socket.SOCK_STREAM)
    sock.connect(server,port)
    is_connected=1
    sock.setblocking(0)

    lines=[""]

def send(data):
    sock.send(data+'\n')            # apparently I'm supposed to check to see if it all got sent.

def recv():
    global lines,is_connected

    if not is_connected:
        return "SOCKETERROR 0 recv() called on unconnected socket!"

    if len(lines)==1:               # only the (incomplete) last line?
        try:
            data=sock.recv(100)
        except socket.error,err:
            if err[0]==11:
                return None         # nothing to read
            else:                   # an error occured?
                sock.close()
                is_connected=0
                return "SOCKETERROR "+str(err[0])+" :"+str(err[1])
        if not data:                # EOF from socket?
            is_connected=0
            return "SOCKETERROR 0 Connection closed by foreign host"
        lines=string.split(lines[0]+data,'\n') # add new data, split into lines
        if len(lines)==1:
            return None             # received something, but was still not enough to complete a line
    line=lines[0][:-1]              # extract first line, minus last char (which is a \n)
    lines=lines[1:]                 # remove a line
    return line

def close():
    global is_connected

    sock.close()
    is_connected=0

#def connected():
#    global is_connected

#    return is_connected

hostname=socket.gethostname