#!/usr/bin/env python
""" User interface

    19990621: * Rewriting for more general (ie. Borland TP6-ish rather than
                TP5.5-ish style windowing)
    19990623: * Hmm, this might actually turn into some useful GUI code.
    19990718: * bold/reverse/underline implemented (as fg^8, swap(fg,bg) and 
                bg^8 respectively.
    19990719: * mIRC-style colours implemented!

WOBBLE (1.5b1)
>>> dir(curses)
['ACS_BBSS', 'ACS_BLOCK', 'ACS_BOARD', 'ACS_BSBS', 'ACS_BSSB', 'ACS_BSSS', 'ACS_BTEE', 'ACS_BULLET',
 'ACS_CKBOARD', 'ACS_DARROW', 'ACS_DEGREE', 'ACS_DIAMOND', 'ACS_GEQUAL', 'ACS_HLINE', 'ACS_LANTERN',
 'ACS_LARROW', 'ACS_LEQUAL', 'ACS_LLCORNER', 'ACS_LRCORNER', 'ACS_LTEE', 'ACS_NEQUAL', 'ACS_PI',
 'ACS_PLMINUS', 'ACS_PLUS', 'ACS_RARROW', 'ACS_RTEE', 'ACS_S1', 'ACS_S3', 'ACS_S9', 'ACS_SBBS', 'ACS_SBSB',
 'ACS_SBSS', 'ACS_SSBB', 'ACS_SSBS', 'ACS_SSSB', 'ACS_SSSS', 'ACS_STERLING', 'ACS_TTEE', 'ACS_UARROW',
 'ACS_ULCORNER', 'ACS_URCORNER', 'ACS_VLINE',

 'A_ALTCHARSET', 'A_ATTRIBUTES', 'A_BLINK', 'A_BOLD', 'A_CHARTEXT', 'A_COLOR', 'A_DIM', 'A_HORIZONTAL',
 'A_INVIS', 'A_LEFT', 'A_LOW', 'A_NORMAL', 'A_PROTECT', 'A_REVERSE', 'A_RIGHT', 'A_STANDOUT', 'A_TOP',
 'A_UNDERLINE', 'A_VERTICAL',

 'COLOR_BLACK', 'COLOR_BLUE', 'COLOR_CYAN', 'COLOR_GREEN', 'COLOR_MAGENTA', 'COLOR_PAIR', 'COLOR_RED',
 'COLOR_WHITE', 'COLOR_YELLOW',

 'KEY_A1', 'KEY_A3', 'KEY_B2', 'KEY_BACKSPACE', 'KEY_BEG', 'KEY_BREAK', 'KEY_BTAB', 'KEY_C1', 'KEY_C3',
 'KEY_CANCEL', 'KEY_CATAB', 'KEY_CLEAR', 'KEY_CLOSE', 'KEY_COMMAND', 'KEY_COPY', 'KEY_CREATE', 'KEY_CTAB',
 'KEY_DC', 'KEY_DL', 'KEY_DOWN', 'KEY_EIC', 'KEY_END', 'KEY_ENTER', 'KEY_EOL', 'KEY_EOS', 'KEY_EXIT',
 'KEY_F0', 'KEY_F1', 'KEY_F10', 'KEY_F11', 'KEY_F12', 'KEY_F13', 'KEY_F14', 'KEY_F15', 'KEY_F16', 'KEY_F17',
 'KEY_F18', 'KEY_F19', 'KEY_F2', 'KEY_F20', 'KEY_F21', 'KEY_F22', 'KEY_F23', 'KEY_F24', 'KEY_F25', 'KEY_F26',
 'KEY_F27', 'KEY_F28', 'KEY_F29', 'KEY_F3', 'KEY_F30', 'KEY_F31', 'KEY_F32', 'KEY_F33', 'KEY_F34', 'KEY_F35',
 'KEY_F36', 'KEY_F37', 'KEY_F38', 'KEY_F39', 'KEY_F4', 'KEY_F40', 'KEY_F41', 'KEY_F42', 'KEY_F43', 'KEY_F44',
 'KEY_F45', 'KEY_F46', 'KEY_F47', 'KEY_F48', 'KEY_F49', 'KEY_F5', 'KEY_F50', 'KEY_F51', 'KEY_F52', 'KEY_F53',
 'KEY_F54', 'KEY_F55', 'KEY_F56', 'KEY_F57', 'KEY_F58', 'KEY_F59', 'KEY_F6', 'KEY_F60', 'KEY_F61', 'KEY_F62',
 'KEY_F63', 'KEY_F7', 'KEY_F8', 'KEY_F9', 'KEY_FIND', 'KEY_HELP', 'KEY_HOME', 'KEY_IC', 'KEY_IL', 'KEY_LEFT',
 'KEY_LL', 'KEY_MARK', 'KEY_MAX', 'KEY_MESSAGE', 'KEY_MIN', 'KEY_MOUSE', 'KEY_MOVE', 'KEY_NEXT', 'KEY_NPAGE',
 'KEY_OPEN', 'KEY_OPTIONS', 'KEY_PPAGE', 'KEY_PREVIOUS', 'KEY_PRINT', 'KEY_REDO', 'KEY_REFERENCE',
 'KEY_REFRESH', 'KEY_REPLACE', 'KEY_RESET', 'KEY_RESIZE', 'KEY_RESTART', 'KEY_RESUME', 'KEY_RIGHT',
 'KEY_SAVE', 'KEY_SBEG', 'KEY_SCANCEL', 'KEY_SCOMMAND', 'KEY_SCOPY', 'KEY_SCREATE', 'KEY_SDC', 'KEY_SDL',
 'KEY_SELECT', 'KEY_SEND', 'KEY_SEOL', 'KEY_SEXIT', 'KEY_SF', 'KEY_SFIND', 'KEY_SHELP', 'KEY_SHOME',
 'KEY_SIC', 'KEY_SLEFT', 'KEY_SMESSAGE', 'KEY_SMOVE', 'KEY_SNEXT', 'KEY_SOPTIONS', 'KEY_SPREVIOUS',
 'KEY_SPRINT', 'KEY_SR', 'KEY_SREDO', 'KEY_SREPLACE', 'KEY_SRESET', 'KEY_SRIGHT', 'KEY_SRSUME', 'KEY_SSAVE',
 'KEY_SSUSPEND', 'KEY_STAB', 'KEY_SUNDO', 'KEY_SUSPEND', 'KEY_UNDO', 'KEY_UP',

 'PAIR_NUMBER', 'WA_ALTCHARSET', 'WA_ATTRIBUTES', 'WA_BLINK', 'WA_BOLD', 'WA_DIM', 'WA_HORIZONTAL',
 'WA_INVIS', 'WA_LEFT', 'WA_LOW', 'WA_NORMAL', 'WA_PROTECT', 'WA_REVERSE', 'WA_RIGHT', 'WA_STANDOUT',
 'WA_TOP', 'WA_UNDERLINE', 'WA_VERTICAL',

 '__doc__', '__file__', '__name__', '__version__',
 'baudrate', 'beep', 'can_change_color', 'cbreak', 'color_content', 'curs_set', 'def_prog_mode',
 'def_shell_mode', 'delay_output', 'doupdate', 'echo', 'endwin', 'erasechar', 'error', 'filter', 'flash',
 'flushinp', 'getsyx', 'getwin', 'halfdelay', 'has_colors', 'has_ic', 'has_il', 'has_key', 'init_color',
 'init_pair', 'initscr', 'intrflush', 'isendwin', 'keyname', 'killchar', 'longname', 'meta', 'newpad',
 'newwin', 'nl', 'nocbreak', 'noecho', 'nonl', 'noqiflush', 'noraw', 'pair_content', 'putp', 'qiflush',
 'raw', 'reset_prog_mode', 'reset_shell_mode', 'setsyx', 'start_color', 'termattrs', 'termname', 'unctrl',
 'ungetch', 'use_env', 'version']

MUSSEL (1.2):
>>> dir(curses)
['A_ALTCHARSET', 'A_BLINK', 'A_BOLD', 'A_DIM', 'A_NORMAL', 'A_REVERSE', 'A_STANDOUT', 'A_UNDERLINE',

 'KEY_A1', 'KEY_A3', 'KEY_B2', 'KEY_BACKSPACE', 'KEY_BEG', 'KEY_BREAK', 'KEY_BTAB', 'KEY_C1', 'KEY_C3',
 'KEY_CANCEL', 'KEY_CATAB', 'KEY_CLEAR', 'KEY_CLOSE', 'KEY_COMMAND', 'KEY_COPY', 'KEY_CREATE', 'KEY_CTAB',
 'KEY_DC', 'KEY_DL', 'KEY_DOWN', 'KEY_EIC', 'KEY_END', 'KEY_ENTER', 'KEY_EOL', 'KEY_EOS', 'KEY_EXIT',
 'KEY_F0', 'KEY_F1', 'KEY_F10', 'KEY_F11', 'KEY_F12', 'KEY_F13', 'KEY_F14', 'KEY_F15', 'KEY_F16', 'KEY_F17',
 'KEY_F18', 'KEY_F19', 'KEY_F2', 'KEY_F20', 'KEY_F21', 'KEY_F22', 'KEY_F23', 'KEY_F24', 'KEY_F25', 'KEY_F26',
 'KEY_F27', 'KEY_F28', 'KEY_F29', 'KEY_F3', 'KEY_F30', 'KEY_F31', 'KEY_F32', 'KEY_F33', 'KEY_F34', 'KEY_F35',
 'KEY_F36', 'KEY_F37', 'KEY_F38', 'KEY_F39', 'KEY_F4', 'KEY_F40', 'KEY_F41', 'KEY_F42', 'KEY_F43', 'KEY_F44',
 'KEY_F45', 'KEY_F46', 'KEY_F47', 'KEY_F48', 'KEY_F49', 'KEY_F5', 'KEY_F50', 'KEY_F51', 'KEY_F52', 'KEY_F53',
 'KEY_F54', 'KEY_F55', 'KEY_F56', 'KEY_F57', 'KEY_F58', 'KEY_F59', 'KEY_F6', 'KEY_F60', 'KEY_F61', 'KEY_F62',
 'KEY_F63', 'KEY_F7', 'KEY_F8', 'KEY_F9', 'KEY_FIND', 'KEY_HELP', 'KEY_HOME', 'KEY_IC', 'KEY_IL', 'KEY_LEFT',
 'KEY_LL', 'KEY_MARK', 'KEY_MAX', 'KEY_MESSAGE', 'KEY_MIN', 'KEY_MOUSE', 'KEY_MOVE', 'KEY_NEXT', 'KEY_NPAGE',
 'KEY_OPEN', 'KEY_OPTIONS', 'KEY_PPAGE', 'KEY_PREVIOUS', 'KEY_PRINT', 'KEY_REDO', 'KEY_REFERENCE',
 'KEY_REFRESH', 'KEY_REPLACE', 'KEY_RESET', 'KEY_RESIZE', 'KEY_RESTART', 'KEY_RESUME', 'KEY_RIGHT',
 'KEY_SAVE', 'KEY_SBEG', 'KEY_SCANCEL', 'KEY_SCOMMAND', 'KEY_SCOPY', 'KEY_SCREATE', 'KEY_SDC', 'KEY_SDL',
 'KEY_SELECT', 'KEY_SEND', 'KEY_SEOL', 'KEY_SEXIT', 'KEY_SF', 'KEY_SFIND', 'KEY_SHELP', 'KEY_SHOME',
 'KEY_SIC', 'KEY_SLEFT', 'KEY_SMESSAGE', 'KEY_SMOVE', 'KEY_SNEXT', 'KEY_SOPTIONS', 'KEY_SPREVIOUS',
 'KEY_SPRINT', 'KEY_SR', 'KEY_SREDO', 'KEY_SREPLACE', 'KEY_SRESET', 'KEY_SRIGHT', 'KEY_SRSUME', 'KEY_SSAVE',
 'KEY_SSUSPEND', 'KEY_STAB', 'KEY_SUNDO', 'KEY_SUSPEND', 'KEY_UNDO', 'KEY_UP',

 '__doc__', '__file__', '__name__', '__version__',
             'beep',                     'cbreak',
                                   'doupdate', 'echo', 'endwin',              'error',           'flash',
 'flushinp',
              'initscr', 'intrflush', 'isendwin', 'keyname', 'meta', 'newwin', 'nl', 'nocbreak', 'noecho', 'nonl', 'noraw', 'raw', 'ungetch', 'version']
>>>

WOBBLE
>>> dir(stdscr)
['addch', 'addnstr', 'addstr', 'attr_off', 'attr_on', 'attr_set', 'attroff', 'attron', 'attrset', 'bkgd', 
 'bkgdset', 'border', 'box', 'clear', 'clearok', 'clrtobot', 'clrtoeol', 'cursyncup', 'delch', 'deleteln', 
 'derwin', 'echochar', 'erase', 'getbegyx', 'getbkgd', 'getch', 'getkey', 'getmaxyx', 'getparyx', 'getstr', 
 'getyx', 'hline', 'idcok', 'idlok', 'immedok', 'inch', 'insch', 'insdelln', 'insertln', 'insnstr', 'insstr', 
 'instr', 'is_linetouched', 'is_wintouched', 'keypad', 'leaveok', 'move', 'mvderwin', 'mvwin', 'nodelay', 
 'notimeout', 'noutrefresh', 'putwin', 'redrawln', 'redrawwin', 'refresh', 'resize', 'scroll', 'scrollok', 
 'setscrreg', 'standend', 'standout', 'subpad', 'subwin', 'syncdown', 'syncok', 'syncup', 'touchline', 
 'touchwin', 'untouchwin', 'vline']

Hmm, possible bug with bkgd(): tends to frustrate my disable-flash-and-enable-16-colour-background hack
by not drawing 'flashing' (or rather, colours 8-15) spaces chars. Any other printable char is fine though...

Bug:
Traceback (innermost last):
  File "ui.py", line 387, in ?
    init(test2)
  File "ui.py", line 359, in init
    main()
  File "ui.py", line 381, in test2
    win=Window(Rect(2,2,20,20))
    self.window.border()
SystemError: old style getargs format uses new features

   Because of IRC's scandanavian origin, the characters {}| are considered to be the lower case
   equivalents of the characters []\, respectively. This is a critical issue when determining the
   equivalence of two nicknames.

0407193133
"""

import curses
import cfg
import string
import re

uncase=string.upper

def set_screen_size(wid,hgt):
    global screen_wid,screen_hgt

    screen_wid=wid
    screen_hgt=hgt

class Rect:
    def __init__(self,x1,y1,x2,y2):
        self.pos=(x1,y1,x2,y2)

    def clip(self):
        global screen_wid,screen_hgt

        x1,y1,x2,y2=self.pos
        if x1<0: x1=0
        if y1<0: y1=0
        if x2>screen_wid-1: x2=screen_wid-1
        if y2>screen_hgt-1: y2=screen_hgt-1

        if x1>x2 or y1>y2:
            return None
        else: 
            return (x1,y1,x2,y2)

    def to_hwyx(self):
        return (self.hgt(),self.wid(),self.pos[1],self.pos[0])

    def to_hw(self):
        return (self.hgt(),self.wid())

    def to_yxyx(self):
        return self.pos

    def wid(self):
        return self.pos[2]-self.pos[0]+1

    def hgt(self):
        return self.pos[3]-self.pos[1]+1

    def x1(self):
        return self.pos[0]

    def y1(self):
        return self.pos[1]

    def x2(self):
        return self.pos[2]

    def y2(self):
        return self.pos[3]

#    def __getitem__(self,item):
#        return self.pos[item]

class Widget:
    def __init__(self,name,window,pos):
        self.window=window
        window.widget[name]=self
        self.pos=pos                     # position relative to window

    def redraw(self):
        raise 'UI','Pure virtual function Widget.redraw() called'

class BufferWidget(Widget):
    """
    This is your typical scrollable static text buffer.
    """
    format_re=re.compile('(\002|\037|\026|\003(?:[0-9]{1,2}(?:,[0-9]{1,2})?)?)')  # ^B, ^_, ^V, ^C

    def __init__(self,name,window,pos):
        Widget.__init__(self,name,window,pos)

        self.pad=apply(window.pad.subpad,pos.to_hwyx())
        self.colour=0x07
#        self.pad.bkgd(attrmap[self.colour]+255)
        self.pad.bkgd(attrmap[self.colour]+ord(' ')*0+255)
        self.pad.bkgdset(attrmap[0x47]+ord('?')) # does nothing?
        self.pad.scrollok(1)
        self.lines=[]
        self.numlines=0
        self.scroll=0

    def fmtecho(self,line):
        """ This is likely to be slow
            >>> re.split('(1|2|3|69)','3xxxx1xxxx2xxx21yyy69(4)\\z6zz')
            ['', '3', 'xxxx', '1', 'xxxx', '2', 'xxx', '2', '', '1', 'yyy', '69', '(4)\\z6zz']
            /exec echo('.IAL','hello 1world')

            >>> re.split('(X[0-9]{1,2},[0-9]{1,2}X?)','xxxX11,1Xyy')
            ['xxx', 'X11,1X', 'yy']
            >>> re.split('(X[0-9]{1,2},[0-9]{1,2}X?)','xxxX11,Xyy')
            ['xxxX11,Xyy']
            >>> re.split('(X[0-9]{1,2}(?:,[0-9]{1,2})?X?)','xxxX11,111Xyy')
            ['xxx', 'X11,11', '1Xyy']

            \003(?:[0-9]{1,2}(?:,[0-9]{1,2})?)?

            blabla ^C5,12to be colored text and background^C blabla
            blabla ^C5to be colored text^C blabla
            blabla ^C3to be colored text ^C5,2other colored text and also background^C blabla
            blabla ^C3,5to be colored text and background ^C8other colored text but SAME background^C blabla
            blabla ^C3,5to be colored text and background ^C8,7other colored text and other background^C blabla

            0 white                                   15 white       0 black
            1 black                                    0 black       1 blue
            2 blue     (navy)                          1 blue        2 green
            3 green                                    2 green       3 cyan
            4 red                                      4 red         4 red
            5 brown    (maroon)                        6 brown       5 magenta
            6 purple                                   5 magenta     6 brown
            7 orange   (olive)                        12 ?l.red      7 l.grey
            8 yellow                                  14 yellow      8 d.grey
            9 lt.green (lime)                         10 l.green     9 l.blue
            10 teal    (a kinda green/blue cyan)       3 cyan       10 l.green
            11 lt.cyan (cyan ?) (aqua)                11 l.cyan     11 l.cyan
            12 lt.blue (royal)                         9 l.blue     12 l.red
            13 pink    (light purple) (fuchsia)       13 ?l.magenta 13 l.magenta
            14 grey                                    8 d.grey     14 yellow
            15 lt.grey (silver)                        7 l.grey     15 white

        """
        global attrmap

        colour=self.colour
        self.pad.bkgdset(attrmap[colour]+ord('.')*0+255)    # this is required (blanks to eol before \n)
        self.pad.addstr('\n',attrmap[colour])
        self.pad.bkgdset(attrmap[0x07]+ord(' ')*0)      # this is required (colour is the allegedly unchangable COLOR_PAIR(0), char is the blanks inside text)
#        self.pad.addstr('\n')
        line=BufferWidget.format_re.split(line)
        while 1:
#            self.pad.addstr(str(line),attrmap[7]) 
            self.pad.addstr(line[0],attrmap[colour])
#            self.pad.addstr('1',attrmap[7])
            del line[0]
#            self.pad.addstr('2',attrmap[7])
            if not line:
                break
#            self.pad.addstr(str(line),attrmap[7])
#            self.pad.addstr('3',attrmap[7])
            code=line[0]
            if code=='\002':         # ^B
                colour=colour^0x08
            elif code=='\037':       # ^_
                colour=colour^0x80
            elif code=='\026':       # ^V
                colour=(colour>>4)+((colour&15)<<4)
            elif code[0]=='\003':    # ^C
                code=string.split(code[1:],',')
#                self.pad.addstr(str(code),attrmap[7])
                if not code[0]: # just a ^C?
#                    self.pad.addstr('a',attrmap[7])
                    colour=self.colour
                else:
#                    self.pad.addstr('b',attrmap[7])
                    colour=(colour&0xF0)+(string.atoi(code[0])&0x0F)
#                    self.pad.addstr('c',attrmap[7])
                    if len(code)>1:
#                        self.pad.addstr('d',attrmap[7])
                        colour=(colour&0x0F)+(string.atoi(code[1])&0x0F)*0x10
#            self.pad.addstr('4',attrmap[7])
            del line[0]
#            self.pad.addstr('5',attrmap[7])
        self.pad.bkgdset(attrmap[self.colour]+ord('=')*0+255) # colour and char of space to eol (until \n is output)
        self.pad.clrtoeol()

    def echo(self,line):
        self.lines.append(line) 
        if self.numlines>=200:
            del self.lines[0]
        else:
            self.numlines=self.numlines+1

#        self.pad.addstr("\n"+line)
#        self.window.pad.touchwin()
#        self.window.refresh()
        self.fmtecho(line)
        refresh()

#    # required?
#    def redraw(self):
#        self.pad.erase()
#        for line in self.lines:
#            self.pad.addstr("\n2"+line)
##        self.window.pad.touchwin()

class ListWidget(Widget):
    """
    This is your typical scrollable list.
    """
    def __init__(self,name,window,pos):
        Widget.__init__(self,name,window,pos)

        self.pad=apply(window.pad.subpad,pos.to_hwyx())
        self.pad.bkgd(attrmap[0x71]+ord('')) # use bkgdset() instead?
        self.list={}

    def insert(self,key,display): # key=internal (unique) key, display=what to display
        self.list[key]=display

        self.pad.addstr("\n"+display)
#        self.window.pad.touchwin()
#        self.window.refresh()
        refresh()

    def delete(self,key):
        del self.list[key]

        # some redrawing here would be good
        self.pad.addstr("\gone:"+key)
#        self.window.pad.touchwin()
#        self.window.refresh()
        refresh()

class TextWidget(Widget):
    """
    One line of changable text
    """
    def __init__(self,name,window,pos):
        if pos.y1()!=pos.y2():
            raise 'UI','TextWidget is not 1 row high '+str(pos.y1())+','+str(pos.y2())
        Widget.__init__(self,name,window,pos)

        self.pad=apply(window.pad.subpad,pos.to_hwyx())
        self.pad.bkgd(attrmap[0x8F]+ord('')) # use bkgdset() instead?
#        self.set('Text goes here')

    def set(self,text):
        self.text=text
        self.pad.addstr(0,0,text)
        self.pad.clrtoeol()
#        self.window.pad.touchwin()
#        self.window.refresh()
        refresh()

#    def redraw(self):
#        pass

class InputWidget(Widget):
    """
    One line of arbitrary input
    """

    format_re=re.compile('([\001-\037])') # null bytes may or may not be a problem.

    def __init__(self,name,window,pos):
        if pos.y1()!=pos.y2():
            raise 'UI','InputWidget is not 1 row high'
        Widget.__init__(self,name,window,pos)

        self.pad=apply(window.pad.subpad,pos.to_hwyx())
        self.pad.bkgd(attrmap[0x1E]+ord('')) # use bkgdset() instead?
#        self.pad.nodelay(1)
#        self.set('Text goes here')
        self.text=''
        self.xpos=0                      # current char=text[xscroll+xpos]
        self.xscroll=0                   # first visible character=text[xscroll]
        self.wid=self.pos.x2()-self.pos.x1()+1
        self.window.input=self           # required?
        self.history=[]                  # 0=most recent entry
        self.histindex=-1                 # -1=editing line not in history

    def refresh(self):
        global attrmap

#        colour=0x1E
        str=InputWidget.format_re.split(self.text[self.xscroll:self.xscroll+self.wid-1])
        self.pad.move(0,0)
        while 1:
            self.pad.addstr(str[0])
            del str[0]
            if not str:
                break
            self.pad.addch(ord(str[0])+64+attrmap[0xE1])
            del str[0]

#        self.pad.addstr(0,0,self.text[self.xscroll:self.xscroll+self.wid-1])
        self.pad.clrtoeol()
        self.window.pad.move(self.pos.y1(),self.pos.x1()+self.xpos)
        refresh()
    
    def left(self):
        if self.xpos==0:
            return
        if self.xpos<=10 and self.xscroll>0:
            self.xscroll=self.xscroll-1
        else:
            self.xpos=self.xpos-1
        self.refresh()

    def right(self):
        if self.xscroll+self.xpos>=len(self.text):
            return
        if self.xpos>=self.wid-1-10 and self.xscroll+self.wid-1<len(self.text):
            self.xscroll=self.xscroll+1
        else:
            self.xpos=self.xpos+1
        self.refresh()  

    def insert(self,key):
#        self.text.insert(self.xscroll+self.xpos,key)
        self.text=self.text[:self.xscroll+self.xpos]+key+self.text[self.xscroll+self.xpos:]
        self.right()

    def bckspc(self):
        if self.xpos==0:                     # at start of line?
            return
        self.text=self.text[:self.xscroll+self.xpos-1]+self.text[self.xscroll+self.xpos:]
        self.left()

    def clear(self):
        self.text=''
        self.xpos=self.xscroll=0
        self.refresh()

    def enter(self):
        self.history.insert(0,self.text)
        self.histindex=-1 
        self.clear()

    def prev(self):
        """ previous entry in history """
        echo('.status',str(len(self.history))+' '+str(self.histindex))
        if self.histindex==len(self.history)-1: # at beginning of history already?
            return
        #hmm, do stuff here? save current line if modified?
        self.histindex=self.histindex+1
        self.text=self.history[self.histindex]
        self.end()

    def home(self):
        self.xpos=self.xscroll=0
        self.refresh()

    def end(self):
        if len(self.text)>=self.wid-1:
            self.xpos=self.wid-1
            self.xscroll=len(self.text)-self.xpos
        else:
            self.xpos=len(self.text)
            self.xscroll=0
        self.refresh()

###############################################################################

class Window:
    """
    This will hopefully cover all windows, including notify windows and the input window.
    """
    def __init__(self,name,pos):
        """
            'name' Must be unique. ie. status window names should probably have '.' prepended
                   Case insensitive, but case preserved, hopefully.
        """
        global attrmap

        self.pos=pos
        self.pad=apply(curses.newpad,pos.to_hw())
        self.pad.bkgd(attrmap[0x8E]+32) # use bkgdset() instead?
        self.pad.box()
        self.pad.nodelay(1)
        self.pad.keypad(1)
        self.name=name
        self.widget={}
#        add(name,self)

        global switchbar
        switchbar.add(self)

    def redraw(self):
#        self.erase()
        for w in self.widget.keys():
            self.widget[w].draw()
#        self.refresh()
        refresh()

    def __getitem__(self,item):
        return self.widget[item]

    def noutrefresh(self):
        """ for internal use only """
        global desktop_pos

        # clip to desktop area here

        clip_left=desktop_pos.x1()-self.pos.x1()
        if clip_left<0: clip_left=0

        clip_right=self.pos.x2()-desktop_pos.x2()
        if clip_right<0: clip_right=0

        clip_top=desktop_pos.y1()-self.pos.y1()
        if clip_top<0: clip_top=0

        clip_bottom=self.pos.y2()-desktop_pos.y2()
        if clip_bottom<0: clip_bottom=0

        # if completely off screen then return
        self.pad.noutrefresh(clip_top,clip_left,
                             self.pos.y1()+clip_top,self.pos.x1()+clip_left,
                             self.pos.y2()-clip_bottom,self.pos.x2()-clip_right)

###############################################################################

# Everything below here could probably go in a separate module

#windows={}
#winlist=[]

class ChannelWindow(Window):
    def __init__(self,name,pos):
        Window.__init__(self,name,pos)
        BufferWidget('buffer',self,Rect(1,2,pos.wid()-16,pos.hgt()-3))
        TextWidget('title',self,Rect(1,1,pos.wid()-2,1))
        InputWidget('input',self,Rect(1,pos.hgt()-2,pos.wid()-2,pos.hgt()-2))
        ListWidget('nicknames',self,Rect(pos.wid()-15,2,pos.wid()-2,pos.hgt()-3))
        self['title'].set(name+" (unknown)")
        self.target=name
#        self.echo=self['buffer'].echo
        refresh()

    def __repr__(self):
        return '<'+self.name+' ChannelWindow>'

class QueryWindow(Window):
    def __init__(self,name,pos):
        Window.__init__(self,name,pos)
        BufferWidget('buffer',self,Rect(1,2,pos.wid()-2,pos.hgt()-3))
        TextWidget('title',self,Rect(1,1,pos.wid()-2,1))
        InputWidget('input',self,Rect(1,pos.hgt()-2,pos.wid()-2,pos.hgt()-2))
        self['title'].set(name)
        self.target=name
        refresh()

    def __repr__(self):
        return '<'+self.name+' QueryWindow>'

class StatusWindow(Window):
    # window names should probably start with a . to avoid name clashes with channels and queries.
    def __init__(self,name,pos):
        Window.__init__(self,name,pos)
        BufferWidget('buffer',self,Rect(1,2,pos.wid()-2,pos.hgt()-3))
        TextWidget('title',self,Rect(1,1,pos.wid()-2,1))
        InputWidget('input',self,Rect(1,pos.hgt()-2,pos.wid()-2,pos.hgt()-2))
        self['title'].set(name[1:])
        self.target=None
        refresh()

    def __repr__(self):
        return '<'+self.name[1:]+'StatusWindow>'

class SwitchBar:
    def __init__(self):
        global screen_wid
        global attrmap

        self.pos=Rect(0,0,screen_wid-1,0)
        self.pad=apply(curses.newpad,self.pos.to_hw())
        self.pad.bkgd(attrmap[0x1E]+ord('=')) # use bkgdset() instead?
#        self.pad.nodelay(1)
#        self.pad.keypad(1)
        self.windows={} # a dictionary of (capitalised_name,user_info) tuples
        self.winlist=[] # a list of uncapitalised window names, top window last

    def noutrefresh(self):
        s=''
        for w in self.winlist:
            s=s+'['+self.windows[w].name+'] '
        self.pad.addstr(0,0,s[:self.pos.wid()])
        self.pad.clrtoeol()
        self.pad.noutrefresh(0,0,self.pos.y1(),self.pos.x1(),self.pos.y2(),self.pos.x2())

    def add(self,win):
        uncap_name=uncase(win.name)
        if self.windows.has_key(uncap_name):
            raise 'UI', 'Key '+win.name+' already exists!'
        self.windows[uncap_name]=win
        self.winlist.append(uncap_name)
        self.noutrefresh()

    def remove(self,name):
        uncap_name=uncase(name)
        if not self.windows.has_key(uncap_name):
            raise 'UI', 'Key '+name+' doesn\'t exist!'
        del self.windows[uncap_name]
        self.winlist.remove(uncap_name)
        self.noutrefresh()

    def find(self,name):
        uncap_name=uncase(name)
        if self.windows.has_key(uncap_name):
            return self.windows[uncap_name]
        else:
            return None

    def curr_win(self):
        if self.winlist:
            return self.windows[self.winlist[-1]]
        else:
            return None

    def select_next(self):
        if self.winlist:
            self.winlist=self.winlist[1:]+self.winlist[:1]
            refresh()

###############################################################################

def all_channels(func,args):
    """ untested! """
#    global window
    global switchbar

#    for w in windows.keys():
#        if w.target and w.target[0] in '#&':
#            func(w,args)

    for w in switchbar.windows.keys():
        if switchbar.windows[w].target and switchbar.windows[w].target[0] in '#&':
            func(w,args)

"""
def find(desc):
    global windows

    desc=uncase(desc)
    if windows.has_key(desc):
        return windows[desc]
    else:
        return None
"""

def find(name):
    global switchbar
    return switchbar.find(name) # return window

"""
def curr_target():
    global windows,winlist

    if not winlist:
        return None
    else:
        return windows[winlist[0]].target
"""

def curr_target():
    global switchbar

    if switchbar.winlist:
#        return switchbar.windows[switchbar.winlist[-1]].name
        return switchbar.winlist[-1]
    else:
        return None

#    currwin=switchbar.curr_win()
#    if currwin:
#        return currwin.target
#    else:
#        return None

#def next():
#    global winlist
#
#    winlist=winlist[1:]+winlist[:1]
#    refresh()

def next():
    global switchbar
    switchbar.select_next()

#def add(desc,win):
#    global windows,winlist

#    desc=upper(desc)
#    if windows.has_key(desc):
#        raise 'UI',repr(desc)+' already add()ed!'
#    else:
#        windows[desc]=win
#        winlist.append(desc)

#    global switchbar
#    switchbar.add(desc,None)

def echo(name,text):
    win=find(name)
    if win:
        win['buffer'].echo(text)
    else:                                # it is possible that everything after here should be in a script event
        win=find(".status")              # this shouldn't really be hard-coded
        if win:
            win['buffer'].echo("["+str(name)+"]:"+text) # neither should this
        else:
            pass                         # give up for now

"""
def remove(desc):
    global windows,winlist
    
    desc=uncase(desc)
    if not windows.has_key(desc):
        raise 'UI',"Couldn't find "+repr(desc)+' in order to remove it!'
    else:
        del windows[desc]
        winlist.remove(desc)
        refresh()

        global switchbar
        switchbar.remove(desc)
"""

def remove(name):
    global switchbar
    switchbar.remove(name)

def refresh():
    global windows,winlist,switchbar

    # draw background here perhaps?
    switchbar.noutrefresh()
    # window that gets refreshed last gets to decide where the cursor goes
    for w in switchbar.winlist:
        switchbar.windows[w].noutrefresh()
    curses.doupdate()

def get_key():
    """ Warning: some code stolen from clirc 0.0.5 source """
#    global windows,winlist
    global switchbar

#    win=windows[winlist[-1]]             # last (ie. top) window
    win=switchbar.curr_win()
#    if not win.__dict__.has_key('input'):
#        return None

    key=win.pad.getch()
    if key==-1: return None              # no key

    if (key>=32 and key<=126) or (key>=160 and key<=255):
        return ('key',key,win)
    elif key>=curses.KEY_MIN and key<=curses.KEY_MAX:
        return (curses.keyname(key),key,win) # named keys
    elif key>=1 and key<=26:
        return ('ctl_'+chr(key+96),key,win) # most ctl keys
    elif key>=27 and key<=31:
        return ('ctl_'+['leftbracket','backslash','rightbracket','caret','underscore'][key-27],key,win)
#    elif key==127:
#        return ('backspace',key,win)     # backspace
    else:
        return ('key_'+repr(key),key,win)# unknown keys

def funk(index):
    return (index&128!=0)*curses.A_BLINK+ \
           (index&8!=0)*curses.A_BOLD+    \
           curses.COLOR_PAIR((index&112)/2+(index&7^7))

# This may need a bit of tweaking.
# I may even decide to return a constant. Thought then again that wouldn't be
# very good as then non-text bits (widgets, etc) would never be bold/dim/tc

def unfunk(index):
    return (index&128!=0)*curses.A_BLINK+ \
           (index&8!=0)*curses.A_BOLD

def ui_init(stdscr):
    """ Initialisation. Must be called before anything else happens.

    Normally a lot of this would happen at the top level, but I need to be able
    to keep an exception handler in place so that curses.endwin() gets caught.
    Of course, I suppose I could use sys.exitfunc...
    """

    global wid,hgt,attrmap,input
    global screen_wid,screen_hgt
    global switchbar,desktop_pos

    curses.noecho()
    curses.cbreak()
    curses.nonl()

    if curses.__dict__.has_key('has_colors') and curses.has_colors():
        curses.start_color()

        # init 64 colour pairs
        colour=[curses.COLOR_BLACK,curses.COLOR_BLUE,curses.COLOR_GREEN,curses.COLOR_CYAN,
                curses.COLOR_RED,curses.COLOR_MAGENTA,curses.COLOR_YELLOW,curses.COLOR_WHITE]
        for index in range(1,64):
            curses.init_pair(index,colour[index&7^7],colour[index/8])

        # map fg/bg colour combinations to attributes
        attrmap=map(funk,range(0,256))
    else:
        attrmap=map(unfunk,range(0,256))

    screen_hgt,screen_wid=stdscr.getmaxyx()
    #stdscr.keypad(1)
    stdscr.bkgd(attrmap[0x1E]+ord('')) 
    switchbar=SwitchBar()
    desktop_pos=Rect(0,1,screen_wid-1,screen_hgt-1)
#    stdscr.refresh()


def init(main):
    global stdscr

    print("Initialising curses")
    stdscr=curses.initscr()

    try:
        ui_init(stdscr)
        main()
    finally:
        curses.endwin()
        print("[H\ncurses deinit'd")

if __name__=="__main__":
    def test1():
        global attrmap

        w=curses.newwin(0,0,0,0)
        for bg in range(0,16):
            for fg in range(0,16):
                w.addstr("Hello ",attrmap[bg*16+fg])
            w.addstr("\n")
            for fg in range(0,16):
                w.addstr("World ",attrmap[bg*16+fg])
            w.addstr("\n")
            w.refresh()

        w.getch()

    def test2():
        win=Window(Rect(15,5,60,20))
        BufferWidget('testbuf',win,Rect(2,2,43,13))
        TextWidget('title',win,Rect(1,1,42,1))
        win['testbuf'].echo("Hello, world!")
#        win['title'].set("Title")
#        win.redraw()

        win.pad.getch()

    def test3():
        win=ChannelWindow('#test',Rect(15,5,75,23))
        win['testbuf'].echo("Hello, world!")
#        win['title'].set("Title")
#        win.redraw()

        win.pad.getch()

    init(test1)
